%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%
%%%  FUNCTION:  compile_metrix_vsnr
%%%
%%%  INPUTS:    NONE
%%%  
%%%  OUTPUTS:   NONE
%%%
%%%  CHANGES:   Builds a MEX interface to a DWT routine called by the VSNR
%%%             metric code; if the build does not succeed, the package defaults
%%%             to using a Matlab-only approach.  Currently, the MEX interface
%%%             is only supported for newer Windows-based platforms.
%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%
%%%  Author:    Matthew Gaubatz
%%%  Version:   1.0
%%%  Date:      01/05/2007
%%%
%%%  Copyright (c) 2007 Visual Communications Lab, Cornell University 
%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function compile_metric_vsnr

fprintf('    Building VSNR MEX interface for DWT...');

if ispc == 1
    fprintf('(Windows)...');    
    try
        compile_imdwt_modified('imdwt_modified.dll');            
    catch
        fprintf('    [Failed!]\n');
        fprintf('    Defaulting to Matlab-based DWT...');        
    end
else
    fprintf('(Linux/Mac)...');    
        fprintf('    [Not Supported!]\n');
        fprintf('    Defaulting to Matlab-based DWT...');        
end

fprintf('[Success!]\n');

