function [imorgCsf,imdistCsf]=getCsf(imorg,imdist)
distArr = {};
orgArr  = {};
restArr = {};
impArr  = {};
% load jpeg2000mat8;
% imorg = double(rgb2gray(im512));
patchSize = size(imorg,1); % Full Size
ref = get_eKMrt(double(imorg));  % Reference image fourier transform
[rowSz,colSz] = size(imorg);
test = zeros(rowSz,colSz);
lev = size(imorg,1) / size(imdist,1);

% Finding Fourier transform power
if(size(imdist,1) == size(imorg,1))
    test = double(get_eKMrt(imdist)); % Test image fourier transform
    doh = 3;
else
    ctr = size(imorg,1)/2;
    beginFrq = ctr-ctr/lev + 1;
    endFrq = ctr+ctr/lev;
    %Multiplied with 2^(lev) to normalize the energy
    test = double(get_eKMrt(imdist)); % Test image fourier transform
    doh = 6;
end


%3) Performing CSF
%        pi . fs . d
%F(la) = ----------------,     H(w) = (a+bw) . exp(-cw)
%        180 . h . 2^(la)
%

FRmax = rowSz / 2;
FCmax = colSz / 2;
col = 1:colSz;
for row = 1:rowSz
    fs(row,:) = sqrt((row-FRmax)^2 + (col - FCmax).^2);
    or(row,:) = atan((row-FRmax)./((col - FCmax) + 10^(-20)));
end
% w =  F_lambda ./(0.85 + 0.15 * or);
% H = (a+b*w).* exp(-c*w);  % CSF value for each subband
% doh = 8;
w = (pi * fs * doh)./180 ;
% w =  F_lambda ./(0.85 + 0.15 * or);

a = 0.31; 
b= 0.69; 
c = 0.29;
H = (a+b*w).* exp(-c*w);  % CSF value for each subband


% end
%4) Contrast Masking(Optional)
N = rowSz * colSz;
fimorgCsf = H .* ref;
if(size(imdist,1) == size(imorg,1))
    fimdistCsf = H .* test;
else
    fimdistCsf = H(beginFrq:endFrq,beginFrq:endFrq) .* test;
end
imorgCsf    = abs(ifft2(fftshift(fimorgCsf)));
imdistCsf   = abs(ifft2(fftshift(fimdistCsf)));


