function [q1,q2]=liFFT_mtd(imorg,imdist)
distArr = {};
orgArr = {};
restArr = {};
impArr = {};
% load jpeg2000mat8;
% imorg = double(rgb2gray(im512));
patchSize = 512; % Full Size
reflev = 4;
ref = get_eK(imorg);  % Reference image fourier transform
[rowSz,colSz] = size(imorg);
test = zeros(rowSz,colSz);
lev = size(imorg,1) / size(imdist,1);

% Finding Fourier transform power
if(size(imdist,1) == size(imorg,1))
    test = double(get_eK(imdist)); % Test image fourier transform
    doh = 6;
else
    ctr = size(imorg,1)/2;
    beginFrq = ctr-ctr/lev + 1;
    endFrq = ctr+ctr/lev;
    %Multiplied with 2^(lev) to normalize the energy
    test(beginFrq:endFrq,beginFrq:endFrq) = 2^(2*lev)*double(get_eK(imdist)); % Test image fourier transform
    doh = 6;
end


%2) Decoupling Loss and Noise: Finding k coefficients for similarity
kArr = clip(test / (ref + 10^(-20)),0,1);
rest = ref .* kArr;
imp = test - rest; 
%3) Performing CSF
%        pi . fs . d
%F(la) = ----------------,     H(w) = (a+bw) . exp(-cw)
%        180 . h . 2^(la)
%

Fmax = rowSz / 2;
col = 1:2*Fmax;
for row = 1:2*Fmax
    fs(row,:) = sqrt((row-Fmax)^2 + (col - Fmax).^2);
    or(row,:) = atan((row-Fmax)./((col - Fmax) + 10^(-20)));
end
% w =  F_lambda ./(0.85 + 0.15 * or);
% H = (a+b*w).* exp(-c*w);  % CSF value for each subband
% doh = 8;
w = (pi * fs * doh)./180 ;
% w =  F_lambda ./(0.85 + 0.15 * or);

a = 0.31, b= 0.69, c = 0.29;
H = (a+b*w).* exp(-c*w);  % CSF value for each subband


% end
%4) Contrast Masking(Optional)
qnum1 = 0;
qden1 = 0;
qnum2 = 0;
qden2 = 0;

bs = 2;
bf = 1;
N = rowSz * colSz;
refprm = H .* ref;
restprm = H .* rest;
testprm = H .* test;

% for ii = 2:3*reflev+1
%     orgArr{ii} = H(ii) * orgArr{ii};
%     restArr{ii} =  H(ii) * restArr{ii};
%     impArr{ii} = H(ii) * impArr{ii};
%     

qnum1 = qnum1 + (sum(sum(restprm.^bs)))^(1/bs);
qden1 = qden1 + (sum(sum(orgprm.^bs)))^(1/bs);
qnum2 = qnum2 + (sum(sum(impprm.^bs)))^(1/bs);

%     
% %     qden2 = qnum2 + sum(restArr{ii}.^bs).^(1/bs);
% end
q1 = qnum1 / qden1;
q2 = qnum2 / N;
mn = mean2(imdist)
