function [q1,q2]=li_mtd_haar(imorg,imdist)
distArr = {};
orgArr = {};
restArr = {};
impArr = {};

%gamma correction
% display device black-level offset (sRGB)
b = 0;
% display device pixel-value-to-voltage gain (sRGB)
k = 0.02874;
% display device gamma (sRGB)
g = 2.2;
% initialize the pixel-value-to-luminance lookup table
pixel_vals = -255:255;
pix2lum_table =abs((b + k*pixel_vals)).^g;
for row = 1 : size(imorg)     
    imorg(row,:) = pix2lum_table(imorg(row,:)+256);
end
for row = 1 : size(imdist)     
    imdist(row,:) = pix2lum_table(imdist(row,:)+256);
end


% load jpeg2000mat8;
% imorg = double(rgb2gray(im512));
reflev = 4;
% ref = dwt2d(imorg,reflev,'97');
% ref = dwt2d(imorg,reflev,'97');
% imdist = dwt2d(imorg,1,'97');
% rec = idwt2d(ref,reflev,'97');
[rowSz,colSz] = size(imorg);
levSz = rowSz / (2^(reflev));
levSzPrv = 1;
ind = 1;
levSz = rowSz / (2^(reflev));
ca = imorg;
halfSize = rowSz / 2;
subbandNum = 3*reflev+1;
for kk =reflev:-1:1
    [ca,chd,cvd,cdd] = dwt2(ca,'db1');
    den = max(max(ca)) - min(min(ca));
    ca =  255 * (ca - min(min(ca))) / den;
    orgArr{subbandNum - ind + 1} = chd(:,:);
    orgArr{subbandNum - ind } = cdd(:,:);
    orgArr{subbandNum - ind - 1} = cvd(:,:);
    if (kk == 1)
        orgArr{subbandNum - ind - 2} = ca(:,:);
        ind = ind +1;
    end
    ind = ind + 3;
    levSz = 2*levSz;
end

if(size(imdist,1) == size(imorg,1))
%     [ca,chd,cvd,cdd] = double(swt2(imdist,reflev,'97'));
    doh = 3;
else
%     [ca,chd,cvd,cdd] = double(swt2(imdist,reflev-1,'97'));
    doh = 6;
end

ind = 1;
ca = imdist;
for kk =reflev:-1:1
    [ca,chd,cvd,cdd] = dwt2(ca,'db1');
    den = max(max(ca)) - min(min(ca));
    ca =  255 * (ca - min(min(ca))) / den;
    if( (size(imdist,1) == size(imorg,1)) || (kk < reflev))
        distArr{subbandNum - ind + 1} = chd;
        distArr{subbandNum - ind } = cdd;
        distArr{subbandNum - ind - 1} = cvd;
    else
        distArr{subbandNum - ind + 1} = zeros(halfSize);
        distArr{subbandNum - ind } = zeros(halfSize);
        distArr{subbandNum - ind - 1} = zeros(halfSize);
        ca = imdist;
    end
    if (kk == 1)
        distArr{subbandNum - ind - 2} = ca;
        ind = ind +1;
    end

    ind = ind + 3;
    levSz = 2*levSz;
end


psi_ind = [2:3:3*reflev+1]; % 2th and 4th orientation for psi difference check 

%2) Decoupling : Finding k coefficients with contrast enhancement and 
%Finding restored image k in [0,1], kk subband
psi_diff = 20; %>1
for subband = 1:3*reflev+1
%     if(any(subband ==  psi_ind))
%         psi_org = atan(orgArr{subband}./(orgArr{subband+2} + 10^(-20))) + pi * (sign(-orgArr{subband+2}) + 1)/2;
%         psi_dist = atan(distArr{subband}./(distArr{subband+2} + 10^(-20))) + pi * (sign(-orgArr{subband+2}) + 1)/2;
%         psi_diff = (psi_org - psi_dist)* 180 /pi;
%     end
    kArr{subband} = clip(distArr{subband}./(orgArr{subband}+10^(-40)),0,1);
    if((subband == 1) ) %|| (psi_diff <= 1)
        restArr{subband} = distArr{subband};
    else
        restArr{subband} = kArr{subband} .* orgArr{subband}; 
    end
    impArr{subband} = distArr{subband} - restArr{subband};
    psi_diff = 20;
end

%3) Performing CSF
%        pi . fs . d
%F(la) = ----------------,     H(w) = (a+bw) . exp(-cw)
%        180 . h . 2^(la)
%
%
a = 0.31, b= 0.69, c = 0.29;
fs = 256;
% doh = 4;
lambda = 1:3;
la_vec = [];
for ii = reflev : -1 : 1
    if(ii == reflev)
        la_vec = [la_vec ii*ones(1,4)];%lambda vector for each subband
    else
        la_vec = [la_vec ii*ones(1,3)];
    end
end
subband = 1:3*reflev+1;
% F_lambda1 = (pi * fs * doh)./(180 * 2.^(la_vec(subband)));

or_ind = [2:3:3*reflev+1 4:3:3*reflev+1];
or =-ones(1,3*reflev+1);
or(or_ind) = 1;
% w =  F_lambda ./(0.85 + 0.15 * or);
% H = (a+b*w).* exp(-c*w);  % CSF value for each subband
% doh = 8;
F_lambda = (pi * fs * doh)./(180 * 2.^(la_vec(subband)));
w =  F_lambda ./(0.85 + 0.15 * or);
H = (a+b*w).* exp(-c*w);  % CSF value for each subband
% end

qnum1 = 0;
qden1 = 0;
qnum2 = 0;
qden2 = 0;

%4) Contrast Masking and Spatial Pooling
weightMat = (1/30)*ones(3);
weightMat(2,2) = 1/15;

bs = 3;
bf = 1;
N = rowSz * colSz / 4;
for ii = 2:3*reflev+1
    orgArr{ii} = H(ii) * orgArr{ii};
    restArr{ii} =  H(ii) * restArr{ii};
    impArr{ii} = H(ii) * impArr{ii};

    noiseMask = conv2(abs(impArr{ii}),weightMat,'same');
    absRest = abs(restArr{ii}); 
    mRestArr{ii} = clip(absRest - noiseMask, 0 , 1000000);
    restMask = conv2(absRest,weightMat,'same');
    absImp = abs(impArr{ii});
    mImpArr{ii} = clip(absImp- restMask, 0 , 1000000);
    aOrgArr{ii} = abs(orgArr{ii});

%     sW = 2^(reflev - ceil((ii-1)/3))
    sW = 1;
    qnum1 = qnum1 + sW*(sum(sum(mRestArr{ii}.^bs)))^(1/bs);
    qden1 = qden1 + sW*(sum(sum(aOrgArr{ii}.^bs)))^(1/bs);
    qnum2 = qnum2 + sW*(sum(sum(mImpArr{ii}.^bs)))^(1/bs);
    
%     qden2 = qnum2 + sum(restArr{ii}.^bs).^(1/bs);
end
q1 = qnum1 / qden1;
q2 = qnum2 / N;
mn = mean2(imdist)
