%Reference
%Soroosh Rezazadeh , Stphane Coulombe 
%"LOW-COMPLEXITY COMPUTATION OF VISUAL INFORMATION FIDELITY IN THE
% DISCRETE WAVELET DOMAIN" ICASSP 2010

function [metrix_value] = metrix_vif_a(reference_image, query_image)
alfa = 0.93;
%Step 1 ) Wavelet decomposition into orgA and refA
[orgA,orgH,orgV,orgD] = dwt2(reference_image,'haar');
[impA,impH,impV,impD] = dwt2(query_image,'haar');

%Step 2 ) Find the vif of the decomposed image with respect to its
% correponding decomposed reference image using scalar GSM 

metrix_value_A = vifsca( orgA, impA);

%Step 3 ) Estimating the image edges
orgE = (0.45*(orgH.^2)+0.45*(orgV.^2)+0.1*(orgD.^2)).^(0.5);
impE = (0.45*(impH.^2)+0.45*(impV.^2)+0.1*(impD.^2)).^(0.5);

%Step 4 ) Find the VIF value for the edges using scalar GSM 
metrix_value_E = vifsca( orgE, impE);

%Calculating the metric
metrix_value = alfa*metrix_value_A + (1-alfa)*metrix_value_E;
