
function [totaltime,avgMBSearch,avgMAD,avgMSE,PSNR,px,py,Anchor_Img,Predict_Img]=motionHBMA5(Target_Img , Anchor_Img , BlockSize , rangs ,range , figureon, reflev, motFile)  
%  
%function [totaltime,avgMBSearch,avgMAD,avgMSE,PSNR]=HBMA(Target_Img,Anchor_Img,Img_Height,Img_Width,BlockSize,rangs,range,figureon)  
%  
%This function calculate block motion vectors (with integer pel accuracy), using hierarchical block matching algorithm.  
%An example of main function calling this function is "MEMBA", which can be entered on the command window.  
%The function also use the function "EBMA" for motion estimation of every macroblock  
%  
%	TargetName,AnchorName:   
%		File Names of Target Frame and Anchor Frame  
%	Img_Height,Img_Width:    
%		Image Height and Width of a Frame  
%  BlockSize:               
%		The size of Macro Block in Frame is BlockSize(1) by BlockSize(2)  
%	rangs,range:        
%		The Search Field in Frame A is from (rangs(1),rangs(2)) to (range(1),range(2))  
%  Target_Img,Anchor_Img,Predict_Img:  
%		Image Matrix for Target Frame, Anchor Frame, Predicted Frame  
%	ox,oy,pxx,pyy:  
%		The location of Motion vector is (ox,oy), (pxx,pyy) for the direction   
%	PSNR:  
%		The peak signal and noise ratio between original image and predicted image  
%	L:  
%		The search level  
%	Author: Xiaofeng Xu, Polytechnic University  4/21/2002  
%   totaltime:  
%       The total time of ME algorithm execution between original and predicted images (platform depended)  
%   avgMBSearch:  
%        The average number of Macro Block matching stages between original and predicted images  
%   avgMAD:  
%       The average MAD between original and predicted images  
%   avgMSE:  
%       The average MSE between original and predicted images  
%   Author: Evgeny Kaminsky, Ben Gurion University 12/18/2002  


%---------------murat---------------------
%mov = aviread('720p50_mobcal_ter_720x480.avi');
%grayfrm = rgb2gray(mov(1).cdata);
% frm = mov(1).cdata;
% grayfrm = rgb2gray(frm);
% reflev = 3;

% [imorg, imdist] = getCsf(imorg,imdist);
[rowSz,colSz] = size(Anchor_Img);
% rowSzC = 4*2^(reflev) * ceil(rowSz/(4*2^(reflev))); 
% colSzC = 4*2^(reflev) * ceil(colSz/(4*2^(reflev)));
% rowDiff = (rowSzC - rowSz)/2; 
% colDiff = (colSzC - colSz)/2;

% AncImg = zeros(rowSzC,colSzC);
% AncImg(1+rowDiff:rowSzC-rowDiff,1+colDiff:colSzC-colDiff) = Anchor_Img;
AncImg = Anchor_Img;
prefrm = dwt2d_norm(double(AncImg),reflev,'97');
% TarImg = zeros(rowSzC,colSzC);
% TarImg(1+rowDiff:rowSzC-rowDiff,1+colDiff:colSzC-colDiff) = Target_Img;
TarImg = Target_Img;
curfrm = dwt2d_norm(double(TarImg),reflev,'97');
% tempArr = prefrm;
[rowSz,colSz] = size(AncImg);

rowLevSz = rowSz / (2^(reflev));
colLevSz = colSz / (2^(reflev)); 
levSzPrv = 1;
ind = 1;
% Reference Wavelet Decomposition
for kk =1:reflev
    if (kk == 1)
        preArr{ind} = prefrm (1:rowLevSz,1:colLevSz);
        ind = ind +1;
    end
    preArr{ind}     = prefrm (rowLevSz+1:2*rowLevSz,1:colLevSz);
    preArr{ind + 1} = prefrm (rowLevSz+1:2*rowLevSz,colLevSz+1:2*colLevSz);
    preArr{ind + 2} = prefrm (1:rowLevSz,colLevSz+1:2*colLevSz);
    ind = ind + 3;
    rowLevSz = 2*rowLevSz;
    colLevSz = 2*colLevSz;
end

rowLevSz = rowSz / (2^(reflev));
colLevSz = colSz / (2^(reflev)); 
ind = 1;


for kk =1:reflev
    if (kk == 1)
        curArr{ind} = curfrm(1:rowLevSz,1:colLevSz);
        ind = ind +1;
    end
    curArr{ind}     = curfrm(rowLevSz+1:2*rowLevSz,1:colLevSz);
    curArr{ind + 1} = curfrm(rowLevSz+1:2*rowLevSz,colLevSz+1:2*colLevSz);
    curArr{ind + 2} = curfrm(1:rowLevSz,colLevSz+1:2*colLevSz);
    ind = ind + 3;
    rowLevSz = 2*rowLevSz;
    colLevSz = 2*colLevSz;
end
PredictFrameSub = zeros(rowSz,colSz); 
%---------------murat---------------------


L=reflev;  
%Number of MB searches;  
c_MB_search=8;  
%Read images from files  
%fid = fopen(Target_Img,'r');  
%Target_Img= fread(fid,[Img_Height,Img_Width]);  
%fclose(fid);  
Target_Img=double(Target_Img);  
  
%fid = fopen(Anchor_Img,'r');  
%Anchor_Img= fread(fid,[Img_Height,Img_Width]);  
%fclose(fid);  
Anchor_Img=double(Anchor_Img);  
   
if (figureon)  
    %Display the results  
    figure;  
    imshow(uint8(Target_Img));  
    title('Target Image')   
end  
t0 = clock;  
m=1;  
Factor=2.^(L);  
  
TargetDown=zeros(3,rowSz,colSz);    
Predict_Img=Target_Img;  
  
rangs(1)=rangs(1)/Factor;  
range(1)=range(1)/Factor;  
  
rangs(2)=rangs(2)/Factor;  
range(2)=range(2)/Factor;  
  
rowSz=rowSz/Factor;  
colSz=colSz/Factor;  
  
  
%Search for all the blocks in Anchor Images of 1st level  
for i=1:BlockSize(1):rowSz-BlockSize(1)+1  
   RangeStart(1)=i+rangs(1);  
   RangeEnd(1)=i+BlockSize(1)-1+range(1);  
   if RangeStart(1)<=1  
      RangeStart(1)=1;  
   end     
   if RangeEnd(1)>rowSz  
      RangeEnd(1)=rowSz;  
   end  
   for j=1:BlockSize(2):colSz-BlockSize(2)+1  
      RangeStart(2)=j+rangs(2);  
      RangeEnd(2)=j+BlockSize(2)-1+range(2);  
	  if RangeStart(2)<=1  
   	    RangeStart(2)=1;  
      end     
      if RangeEnd(2)>colSz  
      	RangeEnd(2)=colSz;  
      end  
      tmpt(:,:)=preArr{1};  
      tmpa(:,:)=curArr{1};  
      [px(m), py(m),MB_search,Predict_Img(i:i+BlockSize(1)-1,j:j+BlockSize(1)-1)]=EBMA(tmpt,tmpa,BlockSize,[i,j],RangeStart,RangeEnd);  
      c_MB_search=MB_search+c_MB_search;  
      ox(m)=j;  
      oy(m)=i;  
      m=m+1;  
   end  
end  
PredictArr{1} = Predict_Img(1:rowSz,1:colSz);
% py and px are motion vectors

if (figureon)  
%Display the results  
    figure;  
    imshow(uint8(preArr{1}));  
    title('TargetDown3')  
    plotMotion(curArr{1},'AnchorDown3',ox,oy,px,py);    
end
writeMotion(px,py,colSz,rowSz,1,motFile);
%Search for all the blocks in Anchor Images of all levels
%or_ind : orientation index
%sub_lev
m = 1;
for ii=2:3*reflev+1 
   %Update all parameters for the currenet level.
    sub_lev = ceil((ii-1)/3);
    or_ind = mod(ii-2,3)+1;
    if(ii <= 4)
        px_or{or_ind}=px;  
        py_or{or_ind}=py;
    elseif(mod(ii-2,3) == 0)
%         px_or{or_ind}=px_or{or_ind}*2;  
%         py_or{or_ind}=py_or{or_ind}*2;
        tempx = (reshape(px_or{or_ind},floor(colSz/4),floor(rowSz/4)))';
        Temp = 2*imresize(tempx,2,'nearest');
        temp2x = zeros(floor(rowSz/2), floor(colSz/2));
        temp2x(1:2*floor(rowSz/4),1:2*floor(colSz/4)) = Temp;

        px = zeros(1,colSz*rowSz/4);
        px = reshape(temp2x',1,floor(colSz/2)*floor(rowSz/2));
        tempy = (reshape(py_or{or_ind},floor(colSz/4),floor(rowSz/4)))';
        Temp = 2*imresize(tempy,2,'nearest');
        temp2y = zeros(floor(rowSz/2),floor(colSz/2));
        temp2y(1:2*floor(rowSz/4),1:2*floor(colSz/4)) = Temp;
        py = zeros(1,colSz*rowSz/4);
        py = reshape(temp2y',1,floor(colSz/2)*floor(rowSz/2));   
        rowSz=rowSz*2;
%         BlockSize = BlockSize*2;
        colSz=colSz*2;  
    end
    line_width=floor(colSz/BlockSize(2));  
    ttt=size(py);  
	m=1;  
    %Search for all the blocks in Anchor Images in the iith level  
    for i=1:BlockSize(1):rowSz-BlockSize(1)+1    
      baseline=double(uint32(i/BlockSize(1)))*double(line_width);  
      for j=1:BlockSize(2):colSz-BlockSize(2)+1  
         %Caculate the search range in Target Images.  
         mindx=floor(baseline+double(uint32(j/BlockSize(2)))+1);  
         if mindx>ttt(2)  
            mindx=ttt(2);  
         end    
         RangeStart(1)=i+py(mindx)+rangs(1);  
	   	 RangeEnd(1)=i+py(mindx)+BlockSize(1)-1+range(1);  
	   	 if RangeStart(1)<=1  
   	   	   RangeStart(1)=1;  
         end     
	   	 if RangeEnd(1)>rowSz  
   	   	   RangeEnd(1)=rowSz;  
	   	 end             
         RangeStart(2)=j+px(mindx)+rangs(2);  
	     RangeEnd(2)=j+px(mindx)+BlockSize(2)-1+range(2);           
         if RangeStart(2)<=1  
   		   RangeStart(2)=1;  
         end     
   		 if RangeEnd(2)>colSz  
      		RangeEnd(2)=colSz;  
         end  
  
         tmpt = preArr{ii};  
         tmpa = curArr{ii};  
            
		 [px_or{or_ind}(m), py_or{or_ind}(m),MB_search, Predict_Img(i:i+BlockSize(1)-1,j:j+BlockSize(1)-1)]=EBMA(tmpt,tmpa,BlockSize,[i,j],RangeStart,RangeEnd);  
         
         c_MB_search=MB_search+c_MB_search;  
   
         ox(m)=j;
	     oy(m)=i;  
      	 m=m+1;  
	  end  
    end 
    PredictArr{ii} = Predict_Img(1:rowSz,1:colSz);
    px=px_or{or_ind};  
    py=py_or{or_ind};
    m = 1;
    if (figureon)  
        %Display the results  
        plotMotion(tmpa,'AnchorDown1',ox,oy,px,py);  
    end
    writeMotion(px,py,colSz,rowSz,ii,motFile);
end 

[rowSz,colSz] = size(AncImg);
rowLevSz = rowSz / (2^(reflev));
colLevSz = colSz / (2^(reflev)); 
ind = 1;
PredictFrameSub = zeros(rowSz,colSz); 
for kk =1:reflev
    if (kk == 1)
        PredictFrameSub (1:rowLevSz,1:colLevSz) = PredictArr{ind};
        ind = ind +1;
    end
    PredictFrameSub(rowLevSz+1:2*rowLevSz,1:colLevSz) = PredictArr{ind};
    PredictFrameSub(rowLevSz+1:2*rowLevSz,colLevSz+1:2*colLevSz) = PredictArr{ind+1} ;
    PredictFrameSub(1:rowLevSz,colLevSz+1:2*colLevSz)=  PredictArr{ind+2};
    ind = ind + 3;
    rowLevSz = 2*rowLevSz;
    colLevSz = 2*colLevSz;
end

PredictFrame = idwt2d_norm(PredictFrameSub,reflev,'97');

totaltime = etime(clock,t0);  
imgsize = rowSz*colSz;  
%Caculate error image  
Error_Img=PredictFrame-double(AncImg);  
%Calculate totalerror  
totalerror=sum(sum(abs(Error_Img)));  
%Calculate average MAD  
avgMAD=totalerror/imgsize;  
%Calculate average MSE  
avgMSE=mean(mean((Error_Img.^2)));  
%Caculate PSNR  
PSNR=10*log10(255*255/avgMSE);  
%Claculate average number of searching stages for each Macro Block  
MB_total=imgsize/(BlockSize(1)*BlockSize(2));  
avgMBSearch = c_MB_search/MB_total;  
  


if (figureon)     
    %Display the results  
    imshow(uint8(Anchor_Img));  
    title('AnchorDown1')  
    hold off  
    pause(2);  

    %Display the results  
    plotMotion(Anchor_Img,'Anchor Image',ox,oy,px,py);  
    figure;  
    imshow(uint8(PredictFrame));  
    title('Predicted Image')  

%     figure;  
%     imshow(uint8(Error_Img));  
%     title('Error Image')  
end 